## mingw-w64-vtk-9.3.0-13.src.tar.zst

=== Filters/Geometry/CMakeLists.txt ===
set(classes
  vtkAbstractGridConnectivity
  vtkAttributeSmoothingFilter
  vtkCompositeDataGeometryFilter
  vtkDataSetRegionSurfaceFilter
  vtkDataSetSurfaceFilter
  vtkExplicitStructuredGridSurfaceFilter
  vtkGeometryFilter
  vtkHierarchicalDataSetGeometryFilter
  vtkImageDataGeometryFilter
  vtkImageDataToUniformGrid
  vtkLinearToQuadraticCellsFilter
  vtkMarkBoundaryFilter
  vtkProjectSphereFilter
  vtkRecoverGeometryWireframe
  vtkRectilinearGridGeometryFilter
  vtkRectilinearGridPartitioner
  vtkStructuredAMRGridConnectivity
  vtkStructuredAMRNeighbor
  vtkStructuredGridConnectivity
  vtkStructuredGridGeometryFilter
  vtkStructuredGridPartitioner
  vtkStructuredNeighbor
  vtkStructuredPointsGeometryFilter
  vtkUnstructuredGridGeometryFilter)

vtk_module_add_module(VTK::FiltersGeometry
  CLASSES ${classes})
vtk_add_test_mangling(VTK::FiltersGeometry)
