=== Filters/Sources/CMakeLists.txt ===
set(classes
  vtkArcSource
  vtkArrowSource
  vtkButtonSource
  vtkCapsuleSource
  vtkCellTypeSource
  vtkConeSource
  vtkCubeSource
  vtkCylinderSource
  vtkDiagonalMatrixSource
  vtkDiskSource
  vtkEllipseArcSource
  vtkEllipticalButtonSource
  vtkFrustumSource
  vtkGlyphSource2D
  vtkGraphToPolyData
  vtkHandleSource
  vtkHyperTreeGridPreConfiguredSource
  vtkHyperTreeGridSource
  vtkLineSource
  vtkOutlineCornerFilter
  vtkOutlineCornerSource
  vtkOutlineSource
  vtkParametricFunctionSource
  vtkPartitionedDataSetSource
  vtkPartitionedDataSetCollectionSource
  vtkPlaneSource
  vtkPlatonicSolidSource
  vtkPointHandleSource
  vtkPointSource
  vtkPolyLineSource
  vtkPolyPointSource
  vtkProgrammableDataObjectSource
  vtkProgrammableSource
  vtkRandomHyperTreeGridSource
  vtkRectangularButtonSource
  vtkRegularPolygonSource
  vtkSelectionSource
  vtkSphereSource
  vtkSuperquadricSource
  vtkTessellatedBoxSource
  vtkTextSource
  vtkTexturedSphereSource
  vtkUniformHyperTreeGridSource)

vtk_module_add_module(VTK::FiltersSources
  CLASSES ${classes})
vtk_add_test_mangling(VTK::FiltersSources)
